/* @(#)getopt.h	1.2 1/21/93 */
#ifndef GETOPT_H
#define GETOPT_H
/* declaration of variables */
extern int	opterr; 	/* switch for error reporting */
extern int	optind;		/* index to current argument */
extern int	optopt;		/* the option currently found */
extern char	*optarg;	/* the argument associated with an option */

/* declaration of the function */
extern 
int
getopt( 
int	argc, 
char	**argv, 
char	*opts);
/* Pre-Conditions 
   argc = the number of arguments in the command line
   argv = the arguments in the command line
   opts = the specification for the options in the command line
   IN { [ option_character [ ':' ] ... ] }
 */
/* Post-Conditions 
   getopt = the option letter found OR
   getopt = '?'
   :- the option did not comply to the specification OR
   getopt = EOF
   :- there are no more options to process
   AND
   optarg = the argument followed by an option that requires an argument
 */
#endif
